/*
 * AppSettings.java
 *
 * code found freely available for use at:  http://www.apsquared.net/BBCode.html
 * 
 */

package com.lovely.bin;

/*
 * AppSettings.java
 *
 */
 
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.util.Date;
import java.util.Hashtable;

class AppSettings {    
    String storeName = null;
    Hashtable settingValues = new Hashtable();
    Hashtable rowIDs = new Hashtable();
    RecordStore rs = null;
    
    //sName :  StoreName to store settings in
    
    AppSettings(String sName) 
    {
        storeName = sName;
        try
        {
            rs = RecordStore.openRecordStore(storeName,true);
            loadSettings();
        } 
        catch(RecordStoreException rse) 
        {
            rse.printStackTrace();
        }   
    }
    
    private void loadSettings()
    {
        settingValues = new Hashtable();
        rowIDs = new Hashtable();
        //for each row add to Hashtable
        try
        {
            RecordEnumeration re = rs.enumerateRecords(null, null, false);
            int rowID;
            while (re.hasNextElement())
            {
                rowID = re.nextRecordId();
                String row = new String(rs.getRecord(rowID));
                int eq = row.indexOf('=');
                String key = row.substring(0,eq);
                String val = row.substring(eq+1);
                settingValues.put(key,val);
                rowIDs.put(key, new Integer(rowID));
            }
            
         }
         catch (Exception e){
             System.out.println("Error occured in loadSettings: ");
             e.printStackTrace();
             return;
          }
   }
   
    
   //Given settingName return the value 
   public String getSetting(String settingName)
   {
       String r = (String)settingValues.get(settingName);
       return r;
    }
      
    //Set setting 
    public boolean setSetting(String settingName, String settingValue)
    {
        Object o = rowIDs.get(settingName);
        if (o == null)
        {
           //add  new setting else
            String theSetting = makeSetting(settingName,settingValue);
           
            byte[] b = theSetting.getBytes();
            try 
            {
                rs.addRecord(b, 0, b.length);
            }
            catch (RecordStoreException rse) 
            {
                System.out.println(rse);
                rse.printStackTrace();
            }
        }
        else
        {
            //update setting
            int rowID = ((Integer)o).intValue();
            String theSetting = makeSetting(settingName,settingValue);
            try{
              rs.setRecord(rowID,theSetting.getBytes(),0,theSetting.length());
            }
            catch (Exception e)
            {
                System.out.println("Error in setSetting: "+e.toString());
                return false;
            }
        }
        commitChanges();
        loadSettings();
        return true;
    }
    
    private void commitChanges()
    {
        close();
        try
        {
            rs = RecordStore.openRecordStore(storeName,true);
        } 
        catch(RecordStoreException rse) 
        {
            rse.printStackTrace();
        }
    }
    
       public void close() 
   {
       try
       {
        if (rs.getNumRecords() == 0) {
            String fileName = rs.getName();
            rs.closeRecordStore();
            rs.deleteRecordStore(fileName);
        } else {
            rs.closeRecordStore();
        }
       }
       catch (Exception e)
       {
           e.printStackTrace();
       }
   }

    
    
    private String makeSetting(String settingName, String settingValue)
    {
        return settingName+"="+settingValue;
    }
    
} 
