/*
 * HTTPInterface.java
 *  Lovely Products 2007 (richard@movethemarkets.com)
 * GPL v2 or later.
 */
 
package com.lovely.bin;

import javax.microedition.io.*;
import java.util.*;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * 
 */
public class HTTPInterface {
    public static String readURL(String url,IStatusable statusable) {
       char[] charbuf = new char[2048];
       HttpConnection conn = null;
       InputStream is = null;
       InputStreamReader isr = null;
       StringBuffer answer = new StringBuffer();
       
       try {
           conn = (HttpConnection) Connector.open( url ,Connector.READ);
           conn.setRequestMethod( HttpConnection.GET );
           conn.setRequestProperty( "User-Agent", JaikuMIDletConstants.getUserAgent());
           conn.setRequestProperty( "Connection", 
                                    "close" );

           int rc = conn.getResponseCode();
           if(rc != HttpConnection.HTTP_OK) {
              statusable.doAlert("HTTP Resp Code Not OK! " + Integer.toString(rc) + " " + conn.getResponseMessage());
              answer = new StringBuffer("HTTP Error: #" + Integer.toString(rc));    
           } 

           is = conn.openInputStream();
           isr = new InputStreamReader(is);

           // read the response, 2048 chars at a time...
           int sz = isr.read(charbuf);
           int total = 0;
           while(sz > 0) {
              total += sz;
              statusable.setStatus(Integer.toString(total) + " bytes read.");    
              answer.append(charbuf,0,sz);
              sz = isr.read(charbuf);    
           }
       }
       catch( Exception e ){
           // handle the error here
           statusable.doAlert("Exception: " + e.toString());
           answer = new StringBuffer(e.toString());
       } finally {
          if(is != null) try { is.close(); } catch(Exception e) { }
          if(isr != null) try { isr.close(); } catch(Exception e) { }
          if(conn != null) try { conn.close(); } catch(Exception e) { }    
       }
       
       return answer.toString();    
    }
    
} 
