/*
 * JaikuBerrySettings.java
 *  Lovely Products 2007 (richard@movethemarkets.com)
 * GPL v2 or later.
 */

package com.lovely.bin;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;


/**
 * 
 */
public class JaikuBerrySettings extends MainScreen {
    EditField nameField;
    EditField[] locField;    
    EditField persKeyField;
    JaikuAppSettings jas;
    
    JaikuBerrySettings(JaikuAppSettings jas_) {    
        super();
        jas = jas_;
        LabelField title = new LabelField
         ("JaikuBerry Settings", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH);
        setTitle(title);
        nameField = new EditField("Name: ",jas.getUserName());
        persKeyField = new EditField("Personal Key: ",jas.getPersonalKey());
        locField = new EditField[JaikuMIDletConstants.NUM_LOCATIONS];
        String[] jasLocation = jas.getLocation();
        add(nameField);
        add(persKeyField);
        for(int i = 0; i < locField.length; ++i) {
            locField[i] = new EditField("Location " + Integer.toString(i+1) + ": ",jasLocation[i]);
            add(locField[i]);
        }
        add(new SeparatorField());
        add(new RichTextField("Note: The 'personal key' is not your password.  Obtain it by visiting http://api.jaiku.com.",Field.READONLY|Field.NON_FOCUSABLE));     
    }
        
    public void save() {
       String[] locs = new String[JaikuMIDletConstants.NUM_LOCATIONS];
       for(int i = 0; i < locs.length; ++i) 
          locs[i] = locField[i].getText();
       jas.updateSettings(nameField.getText(),persKeyField.getText(),locs);    
    }
} 
