/*
 * PostSender.java
 *
 *  Lovely Products 2007 (richard@movethemarkets.com)
 * GPL v2 or later.
 * 
 */

package com.lovely.bin;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import javax.microedition.io.*;
import java.io.OutputStream;
import java.io.InputStream;
import java.io.IOException;

/**
 * In charge of sending a post...
 */
class PostSender extends Thread {
   private byte[] byte_buff;
   PostScreen ps;
   
   public PostSender(PostScreen ps_) {
       ps = ps_;
       byte_buff = new byte[2048]; // not sure how much is actually needed...
   }   
   
   private String user,priv_key,loc,msg;
   private int imageNumber;
   private boolean success_p;
   
   public void postInfo(String user_, String priv_key_, String loc_, String msg_,int imageNumber_) {
     user = user_;
     priv_key = priv_key_;
     loc = loc_;
     msg = msg_;
     imageNumber = imageNumber_;
     success_p = true;
   }
   
   public boolean success() { return success_p; }
   
   private void doAlert(final String alstr) {
      UiApplication.getUiApplication().invokeLater(new Runnable() {
            public void run() {
                Dialog.alert(alstr);
            }
        });   
   }
    
   public void run() {
       success_p = true;
       HttpConnection conn = null;
       OutputStream os = null;
       InputStream is = null;
       
       String url = "http://api.jaiku.com/json";
       String type = "application/x-www-form-urlencoded";
       StringBuffer sbuf = new StringBuffer();
       sbuf.append("user=");
       sbuf.append(URLEncoder.encode(user));
       sbuf.append("&personal_key=");
       sbuf.append(URLEncoder.encode(priv_key));
       sbuf.append("&method=presence.send");
       sbuf.append("&location=");
       sbuf.append(URLEncoder.encode(loc));
       if(imageNumber != 300) { 
          sbuf.append("&icon=");
          sbuf.append(Integer.toString(imageNumber));
       }
       sbuf.append("&message=");
       sbuf.append(URLEncoder.encode(msg));

       String encodedData = sbuf.toString();
       
       try {
           conn = (HttpConnection) Connector.open( url ,Connector.READ_WRITE);
           conn.setRequestMethod( HttpConnection.POST );
           conn.setRequestProperty( "User-Agent", JaikuMIDletConstants.getUserAgent() );
           conn.setRequestProperty( "Content-Type", type );
           conn.setRequestProperty( "Content-Length",
                                     Integer.toString(encodedData.length()));
           conn.setRequestProperty( "Connection", 
                                    "close" );

           os = conn.openOutputStream();
           os.write( encodedData.getBytes() );
           
           int rc = conn.getResponseCode();
           if(rc != HttpConnection.HTTP_OK) {
              doAlert("HTTP Response Code: " + Integer.toString(rc) + " " + conn.getResponseMessage());
              success_p = false;
           } 

           is = conn.openInputStream();
           int sz = is.read(byte_buff);
          
           // if it's not {status: ok} then worry...
           if(sz > 15) {
              success_p = false;
              doAlert("Response: " + new String(byte_buff,0,sz));      
           }
       }
       catch( IOException e ){
            // handle the error here
           success_p = false;
           doAlert(e.toString());
       } finally {
          if(os != null) try { os.close(); } catch(Exception e) { }
          if(is != null) try { is.close(); } catch(Exception e) { }
          if(conn != null) try { conn.close(); } catch(Exception e) { }    
          // now tell the app we're done...
          ps.postSent();
       }
    }
}

